import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 维修记录服务对象基类
 *
 * @export
 * @class EMEQCheckServiceBase
 * @extends {EntityServie}
 */
export default class EMEQCheckServiceBase extends EntityService {

    /**
     * Creates an instance of  EMEQCheckServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  EMEQCheckServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof EMEQCheckServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='emeqcheck';
        this.APPDEKEY = 'emeqcheckid';
        this.APPDENAME = 'emeqchecks';
        this.APPDETEXT = 'emeqcheckname';
        this.APPNAME = 'eamweb';
        this.SYSTEMNAME = 'eam_practice02';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/select`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/select`,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/select`,isloading);
        }
            return Http.getInstance().get(`/emeqchecks/${context.emeqcheck}/select`,isloading);
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/save`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/save`,data,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/save`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/emeqchecks/${context.emeqcheck}/save`,data,isloading);
            return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().put(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().put(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,data,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().put(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/emeqchecks/${context.emeqcheck}`,data,isloading);
            return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks`,data,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks`,data,isloading);
        }
        if(context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emequips/${context.emequip}/emeqchecks`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/emeqchecks`,data,isloading);
        return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/getdraft`,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/getdraft`,isloading);
        }
        if(context.emequip && true){
            return Http.getInstance().get(`/emequips/${context.emequip}/emeqchecks/getdraft`,isloading);
        }
        let res:any = await  Http.getInstance().get(`/emeqchecks/getdraft`,isloading);
        res.data.emeqcheck = data.emeqcheck;
        return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().get(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
            let res:any = await Http.getInstance().get(`/emeqchecks/${context.emeqcheck}`,isloading);
            return res;

    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/checkkey`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/checkkey`,data,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().post(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}/checkkey`,data,isloading);
        }
            return Http.getInstance().post(`/emeqchecks/${context.emeqcheck}/checkkey`,data,isloading);
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emeqcheck){
            return Http.getInstance().delete(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emeqcheck){
            return Http.getInstance().delete(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
        if(context.emequip && context.emeqcheck){
            return Http.getInstance().delete(`/emequips/${context.emequip}/emeqchecks/${context.emeqcheck}`,isloading);
        }
            return Http.getInstance().delete(`/emeqchecks/${context.emeqcheck}`,isloading);

    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMEQCheckServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emeqchecks/fetchdefault`,tempData,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emeqchecks/fetchdefault`,tempData,isloading);
        }
        if(context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emequips/${context.emequip}/emeqchecks/fetchdefault`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/emeqchecks/fetchdefault`,tempData,isloading);
    }
}